C  PROGRAM RASCOS.FOR
C    Compute raised cosine impulse response modified by Hamming window
C
C     G( : ) IS ARRAY TO HOLD IMPULSE RESPONSE SAMPLES, M SAMPLES/BAUD
C         FOR +/- L BAUDS.
C     ALPHA = EXCESS BANDWIDTH FACTOR FOR RAISED COSINE RESPONSE
        DIMENSION G(-512:512)
       CHARACTER*70 FILE1
C
C  COMPUTE RAISED COSINE (HAMMING WINDOWED) BASEBAND SHAPING FILTER
C  IMPULSE RESPONSE
C
        PI = 4.*ATAN(1.)
        WRITE(*,'(A\)') ' ENTER NAME FOR  [t, g(t)] LIST FILE: '
        READ(*,'(A70)') FILE1
        OPEN(7, FILE=FILE1)
       WRITE(*,'(A\)')' ENTER FILENAME FOR g(t) SORTED AS SUBFILTERS: '
        READ(*,'(A70)') FILE1
        OPEN(8, FILE=FILE1)
        WRITE(*,'(A\)')' ENTER FILENAME FOR AMPLITUDE RESPONSE: '
        READ(*,'(A70)') FILE1
        OPEN(11, FILE=FILE1)
        WRITE(*,'(A\)') ' ENTER SYMBOL RATE, FS, IN HZ: '
        READ(*,*) FS
        TB = 1/FS
999     WRITE(*,'(A\)') ' ENTER NUMBER OF SAMPLES/BAUD, M : '
        READ(*,*) M
        WRITE(*,'(A\)') ' ENTER TRUNCATION LIMIT L (+/- L BAUDS): '
        READ(*,*) L
        WRITE(*,'(A\)') ' ENTER EXCESS BANDWIDTH FACTOR, ALPHA : '
        READ(*,*) ALPHA
        ML = M*L
        IF(ML.GT.512) THEN
           WRITE(*,*) ' M*L MUST BE LESS THAN OR EQUAL TO 512.'
           GOTO 999
        ENDIF
        DO 10 K = -ML,ML
      T = FLOAT(K)/FLOAT(M)
        G(K) = H(T,ALPHA)
C  APPLY HAMMING WINDOW TO G
        G(K) = G(K)*(0.54 + 0.46*COS(2.*PI*K/FLOAT(2*ML+1)))
        WRITE(7,*) T,G(K)
  10  CONTINUE
C  SORT IMPULSE RESPONSE AND WRITE OUT FILE CONTAINING SUBFILTER
C  LISTINGS IN FORM THAT CAN BE DIRECTLY USED IN C PROGRAM
C
       WRITE(8,*) '/*  In g[i][j], i is subfilter index, j is coefficien
     +t index in subfilter */'
       DO 20 I=0,M-1
          WRITE(8,*) ' '
         DO 21 K=-ML+I,ML-1,M
  21       WRITE(8,23) I, (K+ML-I)/M, G(K)
  23       FORMAT('      g[',I3,'][',I3,'] = ', E15.6,';')
20     CONTINUE
C
C  COMPUTE FREQUENCY RESPONSE
C
        NTAP = 2*ML + 1
        F=0.
        DF = M*FS/(NTAP*10.)
        DO 3 F = 0, M*FS/2+1, DF
        HRESP=0.
        DO 4 K=1,ML
4       HRESP=HRESP+G(K)*COS(2.*PI*F*K*TB/FLOAT(M))
        HRESP=HRESP*2. + G(0)
        HRESP=20*LOG10(max(ABS(HRESP),1.e-6) )
        IF(F.EQ.0) REF=HRESP
        WRITE(11,*) F,HRESP - REF
3       CONTINUE

      END

C********************************************************************
C   RAISED COSINE IMPULSE RESPONSE FOR ALPHA EXCESS BANDWIDTH
C     THE INPUT T IS THE NORMALIZED TIME (t/BAUD PERIOD)
C
      REAL FUNCTION H(T,ALPHA)
      PI = 4.*ATAN(1.)
      IF(T.EQ.0) THEN
      H = 1.
      ELSE IF(ABS(1.-4.*(ALPHA*T)**2).LT.1.E-6) THEN
        H =(PI/4.)*SIN(PI/(2.*ALPHA))/(PI/(2.*ALPHA))
      ELSE
      H = SIN(PI*T)/(PI*T)*COS(ALPHA*PI*T)/(1.-4.*ALPHA**2*T**2)
      ENDIF
      RETURN
      END
