C       PROGRAM INTERP.FOR
C
C   APPROXIMATE THE IMPULSE RESPONSE SIN(Wct)/(Wct) FOR
C         -(L+0.5) < t/T < (L+0.5)
C    BY CUBIC POLYNOMIALS OVER EACH INTERVAL OF WIDTH T.
C
C  NUM1  NUMBER OF SAMPLES/INTERVAL USED FOR LEAST SQUARES FIT
C         INCLUDING END POINTS
C
        DOUBLE PRECISION H(200), X(200), POLY(4,200),G
        DOUBLE PRECISION ALPHA,DALPHA,T,TT,COEFS(23),DELTA
        PI = 3.1415926535
        OPEN(3,FILE = 'H.DAT')
        OPEN(4,FILE = 'HFIT.DAT')
        OPEN(5,FILE = 'FITERR.DAT')
        WRITE(*,'(A\)') ' ENTER NUMBER OF TAPS (MUST BE ODD NUMBER): '
        READ(*,*) NTAPS
        LTAPS = (NTAPS - 1)/2
        TMAX = LTAPS + 0.5
        WRITE(*,'(A\)')' ENTER SAMPLING AND CUTOFF FREQUENCIES IN HZ: '
        READ(*,*) FS, FC
        WRITE(*,'(A\)')' ENTER OVERLAP G: '
        READ(*,*) G
        T = 1/FS
        NUM1 = 101
        DALPHA = (1.+2.*G)/DBLE(NUM1 - 1)
        DELTA = 1./DBLE(NUM1 - 1)
C
        WRITE(*,*) ' '
        WRITE(*,*)' CUTOFF FREQUENCY = ',FC,' SAMPLING FREQUENCY = ',FS
        WRITE(*,*)' NUMBER OF TAPS = ',NTAPS
        WRITE(*,*) '    L          C(0,L)        C(1,L)         C(2,L)  
     +      C(3,L)'
        DO 2 L= -LTAPS,LTAPS
        ALPHA = -0.5-G
        DO 1 I=1,NUM1
          X(I) = ALPHA
          TNORM = L + ALPHA
          TT = (L + ALPHA)*T
          IF(TT.EQ.0) THEN
             H(I) = 2.*FC/FS
          ELSE
            H(I) = (2.*FC/FS)*SIN(2.*PI*FC*TT)/(2*PI*FC*TT)
          ENDIF
          ALPHA = ALPHA + DALPHA
C    USE HANNING WINDOW
        H(I) = H(I)*(0.5 + 0.5*COS(PI*TNORM/TMAX))
        WRITE(3,*) TNORM,H(I)
   1    CONTINUE
        CALL POLYFIT(NUM1,X,H,3,ODEGRE,COEFS)
        DO 3 LL = 1,4
   3    POLY(LL, L+LTAPS+1) = COEFS(LL)
        WRITE(*,'(1X,I5,4F15.6)') L+LTAPS+1,(POLY(LL,L+LTAPS+1),LL=1,4)
  2     CONTINUE
        REWIND 3
C
C     COMPUTE FITTED RESPONSE AND ERROR
C
        DO 4 L= -LTAPS,LTAPS
        ALPHA = -0.5
        DO 5 I=1,NUM1
          TNORM = L + ALPHA
          HFIT = 0.
          DO 6 NN = 1,4
   6      HFIT = HFIT + POLY(NN,L+LTAPS+1)*ALPHA**(NN-1)
          WRITE(4,*) TNORM,HFIT
          ALPHA = ALPHA + DELTA
   5    CONTINUE
 4      CONTINUE
        REWIND 4
        DO 7 I = 1,NTAPS*NUM1
        READ(3,*) TNORM,HA
        READ(4,*) TNORM,HFIT
        FITERR = HA - HFIT
  7     WRITE(5,*) TNORM,FITERR
        END
